#-Blackjack Player


DELETE FROM config WHERE Name='blackjack_serve' OR Name='blackjack_ops_level' OR Name='blackjack_voice_level';

INSERT INTO config VALUES ('blackjack_serve','true','Let the bot serve blackjack.');
INSERT INTO config VALUES ('blackjack_ops_level','true','Money required to gain ops.');
INSERT INTO config VALUES ('blackjack_voice_level','true','Money required to gain voice.');

#Data table for players
DROP TABLE IF EXISTS mod_blackjack_players;
CREATE TABLE mod_blackjack_players (
	Nick VARCHAR(50) NOT NULL,
	Channel VARCHAR(50) NOT NULL,
	Money INT UNSIGNED NOT NULL,
	Data TEXT
);

#Data table for donatations.
DROP TABLE IF EXISTS mod_blackjack_donations;
CREATE TABLE mod_blackjack_donations (
	Nick VARCHAR(50) NOT NULL,
	Amount INT UNSIGNED NOT NULL,
	NickTo VARCHAR(50) NOT NULL
);

#Data table to track the dealer
DROP TABLE IF EXISTS mod_blackjack_dealer;
CREATE TABLE mod_blackjack_dealer (
	Channel VARCHAR(50) NOT NULL,
	Data TEXT NOT NULL
);

DELETE FROM modules WHERE ModDir='blackjack';
INSERT INTO modules(ModID, ModTypes, ModDir, ModName) VALUES (NULL, "['+QUIT','+PART','+JOIN']", 'blackjack','Blackjack Player');

DELETE FROM commands WHERE CmdName='bj';
INSERT INTO commands (CmdName, CmdAccess, CmdExtraPath) VALUES ('bj', "", 'mods/blackjack/cmds');

