--Channel Management

DROP TABLE IF EXISTS mod_channel_management_banlists;
CREATE TABLE mod_channel_management_banlists (
	Channel VARCHAR(50) NOT NULL,
	Mask VARCHAR(150) NOT NULL
);

DROP TABLE IF EXISTS mod_channel_management_akick;
CREATE TABLE mod_channel_management_akick (
	Channel VARCHAR(50) NOT NULL,
	Mask VARCHAR(150) NOT NULL,
	Timeout INT UNSIGNED NOT NULL DEFAULT '120',
	Reason VARCHAR(100)
);

DROP TABLE IF EXISTS mod_channel_management_avoice;
CREATE TABLE mod_channel_management_avoice (
	Channel VARCHAR(50) NOT NULL,
	Mask VARCHAR(150) NOT NULL,
	ReqLogin ENUM('Y', 'N') NOT NULL DEFAULT 'Y'
);

DROP TABLE IF EXISTS mod_channel_management_aop;
CREATE TABLE mod_channel_management_aop (
	Channel VARCHAR(50) NOT NULL,
	Mask VARCHAR(150) NOT NULL,
	ReqLogin ENUM('Y', 'N') NOT NULL DEFAULT 'Y'
);

DELETE FROM modules WHERE ModDir='channel_management';
INSERT INTO modules(ModDir, ModName, ModTypes) VALUES ('channel_management', 'Channel Management', '');

DELETE FROM commands WHERE CmdName='cm';
INSERT INTO commands(CmdName, CmdAccess, CmdExtraPath) VALUES('cm', '', 'mods/channel_management/cmds');

