<?php
$file="CommandAPI.php";
while (!file_exists(realpath($file))){
	$file="../$file";
}
include($file);

//If the person has BOT_OP or MASTER, let it go
if (($_User->hasMode('MASTER') || $_User->hasMode('BOT_OP')) && $_User->isLoggedIn()){
	exit;
}

$CmdKeys=$_Bot->getCfg('command_key');
//Capture the command name
if (preg_match("/^[$CmdKeys](.[^ ]*)/", $INFO['MSG'], $Matches)){
	//Wise_msg('#wiser', 'Found command '.$Matches[1]);
	$Matches[1]=strtolower($Matches[1]);
	if ($_Bot->cmdExists($Matches[1])){
		//Wise_msg('#wiser', 'Command exists.');
		if ($_Bot->getInfo('shutdown_active')=='Y' && $Matches[1] != 'limit-wake'){
			//Wise_msg('#wiser', 'Command Canceled. Bot was shutdown.');
			Wise_Cancel_Cmd();
			exit;
		}
		$TimeLimit=$_Bot->getCfg('command_limit_timeout') * 60;
		$Chan=Channel::Exists($INFO['DEST']);
		if ($Chan){
			//Wise_msg('#wiser', 'Was used in a channel.');
			$res=db_query("SELECT 1 FROM mod_command_limits WHERE Command='{$Matches[1]}'");
			if ($res && db_num_rows($res) > 0){
				$Chan=new Channel($INFO['DEST']);
				$res=db_query("SELECT Time, Warned FROM mod_command_limit_info WHERE Chan='".$Chan->getName()."'");
				if (!$res || db_num_rows($res)==0){
					db_query("INSERT INTO mod_command_limit_info(Chan, Time, Warned) VALUES ('".$Chan->getName()."','".time()."','0')");
					exit;
				}
				
				$row=db_get_row($res);
				if (time()-$row->Time < $TimeLimit){
					if (time()-$row->Warned > 60){
						$time=time()-$row->Time;
						$time=$TimeLimit-$time;
						//Wise_Msg($Chan->getName(), "Commands shutdown for the next ".timeFormat($time));
						db_query("UPDATE mod_command_limit_info SET Warned=".time()." WHERE Chan='".$Chan->getName()."'");
					}
					Wise_cancel_cmd();
				}
				else {
					db_query("UPDATE mod_command_limit_info SET Time='".time()."' WHERE Chan='".$Chan->getID()."'");
				}
			}
		}
	}
}
?>
