#-Command Limiter

DROP TABLE IF EXISTS mod_command_limit_info;
CREATE TABLE mod_command_limit_info (
	Chan VARCHAR(50) NOT NULL,
	Time INT UNSIGNED NOT NULL,
	Warned INT UNSIGNED NOT NULL
);

DROP TABLE IF EXISTS mod_command_limits;
CREATE TABLE mod_command_limits (
	Command VARCHAR(30) NOT NULL
);

DELETE FROM modules WHERE ModDir='command_limit';
INSERT INTO modules(ModID, ModTypes, ModDir, ModName) VALUES (NULL,"['PRIVMSG']", 'command_limit','Command Limiter');

DELETE FROM commands WHERE CmdName='limit-set' OR CmdName='limit-shutdown' OR CmdName='limit-wake';
INSERT INTO commands(CmdID, CmdName, CmdAccess, CmdExtraPath) VALUES (NULL, 'limit-set',"['BOT_OP']",'mods/command_limit/cmds/');
INSERT INTO commands(CmdID, CmdName, CmdAccess, CmdExtraPath) VALUES (NULL, 'limit-shutdown',"['BOT_OP','CHAN_OP']",'mods/command_limit/cmds/');
INSERT INTO commands(CmdID, CmdName, CmdAccess, CmdExtraPath) VALUES (NULL, 'limit-wake',"['BOT_OP','CHAN_OP']",'mods/command_limit/cmds/');

DELETE FROM config WHERE Name='command_limit_timeout';
INSERT INTO config VALUES ('command_limit_timeout','.5','Time between commands<BR>(Minutes)');

