<?php
$file="CommandAPI.php";
while (!file_exists(realpath($file))){
	$file="../$file";
}
include($file);


$Msg=trim($INFO['MSG']);

function parseKarma($Msg){
	$KarmaCount=array();
	$embedLevel=0;
	$inParan=false;
	$curTerm='';
	$pmCount=0;

	for($i=0; $i<strlen($Msg); $i++){
		switch ($Msg{$i}){
			case ' ':{
				if (!$inParan){
					$curTerm='';
				}
				else {
					$curTerm.=' ';
				}
				break;
			}
			case '(':{
				if (!$inParan){
					$inParan=true;
				}
				$embedLevel++;
				break;
			}
			case ')':{
				$embedLevel--;
				if ($embedLevel <= 0){
					$inParan=false;
				}
				break;
			}
			case '+':{
				$pmCount++;
				if ($pmCount==2){
					$pmCount=0;
					if (!empty($curTerm)){
						if (!isset($KarmaCount[$curTerm])){
							$KarmaCount[$curTerm]=0;
						}
						$KarmaCount[$curTerm]++;
					}
				}
				break;
			}
			case '-':{
				$pmCount--;
				if ($pmCount==-2){
					$pmCount=0;
					if (!empty($curTerm)){
						if (!isset($KarmaCount[$curTerm])){
							$KarmaCount[$curTerm]=0;
						}
						$KarmaCount[$curTerm]--;
					}
				}
				break;
			}
			default:{
				$pmCount=0;
				$curTerm.=$Msg{$i};
			}
		}
	}
	return $KarmaCount;
}


if (strpos($Msg, '++') || strpos($Msg, '--')){
	$info=parseKarma($Msg);
	foreach ($info as $term=>$karma){
		if ($_Bot->getCfg('allow_nested_karma')==false){
			if ($karma > 0){
				$karma=1;
			}
			if ($karma < 0){
				$karma=-1;
			}
		}
		$Query="SELECT Count FROM mod_karma WHERE Word='{$term}'";
		$res=db_query($Query);
		$UID=$_User->getID();
		if (!$res || db_num_rows($res)==0){
			$Query="INSERT INTO mod_karma(Word, Count) VALUES ('{$term}','{$karma}')";
			db_query($Query);
			$Query="INSERT INTO mod_karma_voters(Word, NickID, Time) VALUES ('{$term}','{$UID}','".time()."')";
			db_query($Query);
		}
		else {
			$row=db_get_row($res);
			$karma+=$row->Count;
			$Query="SELECT 1 FROM mod_karma_voters WHERE NickID='".$_User->getID()."' AND (UNIX_TIMESTAMP()-time) > 3600";
			$res=db_query($Query);
			if ($res && db_num_rows($res)>=0){
				$Query="UPDATE mod_karma SET count='{$karma}' WHERE word='{$term}'";
				db_query($Query);
				$Query="UPDATE mod_karma_voters SET time='".time()."' WHERE NickID='{$UID}' AND Word='{$term}')";
				db_query($Query);
			}
		}
	}
}


function sprint_r($obj, $keepOld=true){
	if ($keepOld){
		$OldContent=ob_get_contents();
	}
	else {
		$OldContent='';
	}

	@ob_end_clean();
	ob_start();
	print_r($obj);
	$Content=ob_get_contents();
	ob_end_clean();
	
	if ($keepOld){
		ob_start();
		echo $OldContent;
	}
	return $Content;
}

?>
