<?php
$file="CommandAPI.php";
while (!file_exists(realpath($file))){
	$file="../$file";
}
include($file);

$PathToManual="../";
$Msg=substr($INFO['MSG'], strlen("~lookup"));
$Msg=trim($Msg);

$To=stristr($Msg, " to ");
if ($To){
	$To=trim($To);
	$To=substr($To, 2);
	$To=trim($To);
}
else {
	$To=$INFO['DEST'];
	if (strToUpper($To)==strToUpper($_Bot->getNick())){
		$To=$_User->getNick();
	}
}

$Lookup=$Msg;
if (stristr($Msg, ' -m ')){
	$Lookup=str_replace(' -m ', '',$Lookup);
}
if (stristr($Msg, ' to ')){
	$Lookup=str_replace(' to '.$To, '', $Lookup);
}

$What='c';
if ((strstr($Lookup, '*') || strstr($Lookup, '?')) && ($Lookup != '?:' && $Lookup != '*' && $Lookup != '*=')){
	$What='m';
}


//Finally, change the * and ? to (.*) and . for regex matching.  If it is a match lookup.
if ($What=='m'){
	$Lookup=str_replace('*','(.*)',$Lookup);
	$Lookup=str_replace('?','.',$Lookup);
	$Lookup='^'.$Lookup.'$';
}
else {
	if (substr($Lookup, strlen($Lookup)-2)=='()'){
		$Lookup=substr($Lookup, 0, -2);
	}
}

//First Off.  If it's a match.  match the stuff then exit.
/////////////////////////  Match Lookup     ///////////////////////////////////////////////////////////////////
if ($What=='m'){
	$List=file($PathToManual."PHP_Manual.txt");
	$matches=array();
	$i=1;
	foreach ($List as $Line){
		list($filename, $returnval, $name, , $description)=explode("\t\t", trim($Line));
		if (eregi($Lookup, strtolower($name))){
			if ($i>10){ break; }
			$matches[$i++]=$name;
		}
	}
	$List=file($PathToManual."PHP_Manual_structures.txt");
	foreach ($List as $Line){
		list($filename, $struct, $syntax, $description)=explode("\t\t", trim($Line));
		if (eregi($Lookup, strtolower($struct))){
			if ($i>10){ break; }
			$matches[$i++]=$struct;
		}
	}
	$Lookup=substr($Lookup, 1, -1);
	$Lookup=str_replace('(.*)', '*', $Lookup);
	$Lookup=str_replace('.','?',$Lookup);
	$List='Possible Matches to '.$Lookup.': ';
	foreach ($matches as $match){
		$List.=$match.', ';
	}
	if (count($matches)==0){
		$List.="[None], ";
	}
	Wise_Msg($To, substr($List, 0, -2));
	exit;
}
else {
	/////////////////////////  Function Lookup  ///////////////////////////////////////////////////////////////////
	$List=file($PathToManual."PHP_Manual.txt");
	$match=false;
	foreach ($List as $Line){
		list($filename, $returnval, $name, $arguments, $ver, $description)=explode("\t\t", trim($Line));
		if ($Lookup==strtolower($name)){
			$match=1;
			break;
		}
	}
	$arguments=Lookup_ParseCodes($arguments);
	$description=Lookup_ParseCodes($description);
	if ($match!=false){
		Wise_Msg($To, "Function: $name -- $returnval $name $arguments");
		Wise_Msg($To, "$ver $description");
		Wise_Msg($To, "http://www.php.net/$Lookup");
		exit;
	}
	///////////////////////////  Operator Lookup  ///////////////////////////////////////////////////////////////////
	$List=file($PathToManual."PHP_Manual_operators.txt");
	$match=false;
	foreach ($List as $Line){
		list($filename, $operator, $description)=explode("\t\t", trim($Line));
		if (strtolower($operator)==$Lookup){
			$match=1;
			break;
		}
	}

	$description=Lookup_ParseCodes($description);
	if ($match!=false){
		Wise_Msg($To, "Operator: $operator");
		Wise_Msg($To, "$description");
		Wise_Msg($To, "http://www.php.net/manual/en/$filename");
		exit;
	}
	///////////////////////////////  Control Structures Lookup  //////////////////////////////////////////////////////
	$List=file($PathToManual."PHP_Manual_structures.txt");
	$match=false;
	foreach ($List as $Line){
		list($filename, $struct, $syntax, $description)=explode("\t\t", trim($Line));
		if ($Lookup==strtolower($struct)){
			$match=1;
			break;
		}
	}
	$syntax=Lookup_ParseCodes($syntax);
	$description=Lookup_ParseCodes($description);
	if ($match!=false){
		Wise_Msg($To, "Control: $syntax");
		Wise_Msg($To, "$description");
		Wise_Msg($To, "http://www.php.net/manual/en/$filename");
	}
	else {
		switch (strtolower($Lookup)){
			case 'boobs':{
				Wise_Msg($To, "Yea, I got your boobs, want them back?");
				break;
			}
			case 'data':{
			}
			case 'content':{
				Wise_Msg($To, "Bah, you caught me, I am content-less");
				break;
			}
			default:{
				if (User::exists($Lookup)){
					Wise_Msg($To, "Yea, $Lookup is here, even though I wish they weren't.");
				}
				else if (Channel::exists($Lookup)){
					Wise_Msg($To, "Yea, $Lookup is here.");
				}
				else {
					Wise_Msg($To, "Sorry, I was unable to find '$Lookup' in my databases");
				}
			}
		}
	}
	exit;
}

function Lookup_ParseCodes($des){
	global $_Bot;
	$des=eregi_replace("\[/?b]",$_Bot->getInfo('bold'),$des);
	$des=eregi_replace("\[/?u]",$_Bot->getInfo('underline'),$des);
	$des=eregi_replace("\[/?k]",$_Bot->getInfo('color'),$des);
	return $des;
}

?>
