<?php
$file="CommandAPI.php";
while (!file_exists(realpath($file))){
	$file="../$file";
}
include($file);

$To=$_Bot->getDest($INFO['DEST'], $_User->getNick());
if ($To==$_User->getNick()){
	exit;
}

$res=db_query("SELECT Regex, Command, ExtraModes FROM mod_responses ORDER BY ResponseID");
if (!$res || db_num_rows($res)==0){
	exit;
}

while ($row=db_get_row($res)){
	$row->Command=trim($row->Command);
	if (preg_match($row->Regex, $INFO['MSG'], $matches)){
		$e=strpos($row->Command, ' ');
		$CmdName=substr($row->Command, 0, ($e===false)?strlen($row->Command):$e);
		$Logout=!$_User->isLoggedin();
		if (!empty($row->ExtraModes)){
			if ($Logout){
				$_User->login(null);
			}
			$Modes=$_User->getModesArray();
			$TempModes=array_merge($Modes, toArray($row->ExtraModes));
			$Query="UPDATE users SET Modes='".addslashes(toArrayString($TempModes))."' WHERE NickID='".$_User->getID()."'";
			db_query($Query);
		}
		if ($_Bot->commandAllowed($_User, $CmdName, $INFO['DEST'], true)){
			$row->Command=replaceValues($row->Command, $matches, $_User, $_Bot, $INFO);
			$OldMsg=$INFO['MSG'];
			$INFO['MSG']=$row->Command;
			runCommand($_User, $INFO, $CmdName, false);
			$INFO['MSG']=$OldMsg;
		}
		if (!empty($row->ExtraModes)){
			db_query("UPDATE users SET Modes='".addslashes(toArrayString($Modes))."' WHERE NickID='".$_User->getID()."'");
		}
		if ($Logout){
			$_User->logoff();
		}
	}
}

function replaceValues($cmd, $matches, $User, $Bot, $INFO){
	$cmd=str_replace('$Nick', $User->getNick(), $cmd);
	$cmd=str_replace('$Chan', $INFO['DEST'], $cmd);
	$cmd=str_replace('$Bot', $Bot->getNick(), $cmd);
	for ($i=0; $i<count($matches); $i++){
		$cmd=str_replace('$'.$i, $matches[$i], $cmd);
	}
	return $cmd;
}

function runCommand($User, $INFO, $Cmd){
	global $_Bot;
	$file="__{$Cmd}.php";

	//Remove any null characters.
	$file=str_replace("%00","",$file);
	$file=str_replace(chr(0), "", $file);

	//Get the command data from the config
	$host=$_Bot->getCfg('cmd_host');
	$port=$_Bot->getCfg('cmd_port');
	$path=$_Bot->getCfg('cmd_path');
	$user=$_Bot->getCfg('cmd_user');
	$pass=$_Bot->getCfg('cmd_pass');

	//Get the extra path information if it exists
	$res=db_query("SELECT CmdExtraPath as path FROM commands WHERE CmdName='{$Cmd}'");
	if ($res && db_num_rows($res)==1){
		$row=db_get_row($res);
		//Remove trailing / or \ if they put it on the path.
		if ($row->path{0}=='/' || $row->path{0}=='\\'){
			$row->path=substr($row->path, 1);
		}
		$path.='/'.$row->path;
	}


	//Remove trailing / or \ if they put it on the path.
	if ($path{strlen($path)-1}=='/' || $path{strlen($path)-1}=='\\'){
		$path=substr($path, 0, -1);
	}

	//Serialize and encode the info array.
	foreach ($INFO as $key=>$val){
		$INFO[$key]=urlencode($val);
	}

	$PostData="INFO=".urlencode(serialize($INFO));

	//setup the headers
	$Headers="POST $path/$file HTTP/1.0\r\n".
			"Host: $host\r\n".
			"Connection: Close\r\n".
			((!empty($user) || !empty($pass))?"Authorization: Basic ".base64_encode($user.":".$pass)."\r\n":"").
			"User-agent: Wise Command Engine v0.01\r\n".
			"Content-type: application/x-www-form-urlencoded\r\n".
			"Content-length: ".strlen($PostData)."\r\n".
			"\r\n".
			$PostData;

	//Try to open the connection to the server
	$fs=fsockopen($host, $port, $errno, $errno, 5);
	if (!$fs){
		return false;
	}
	
	//We should be connected.  Send headers
	fputs($fs, $Headers);

	//Wait for response
	$results='';
	$headersDone=false;

	$line=trim(fgets($fs, 1024));
	$line=(int)substr($line, 9, 3);
	if ($line != 200){
		fclose($fs);
		Wise_Eval("output('Failed to run {$path}/{$file}.  Got error code {$line}');");
		exit;
	}
	while ($line=fgets($fs, 1024)){
		if ($headersDone==true){
			$results.=$line;
		}
		if (trim($line)=='' && $headersDone==false){
			$headersDone=true;
		}
	}

	if ($headersDone==false){
		return false;
	}
	else {
		if ($results != '' ){
			//Parse the results for some codes.
			//First split into an array
			$results=explode("\n",$results);
			foreach ($results as $line){
				if (!empty($line)){
					if ($line{0}==':'){
						$end=strpos($line, ':', 2)-1;
						$code=substr($line, 1, $end);
						$data=substr($line, $end+2);
						switch($code){
							case 'EVAL':{
								eval(urldecode($data));
								break;
							}
							case 'SLEEP':{
								if(empty($data)){
									$data=2;
								}
								$data=intval($data);
								if ($data>10){
									$data=10;
								}
								sleep($data);
								break;
							}
							case 'RELOAD':{
								$_Bot->reload();
								break;
							}
						}
					}
					else {
						Wise_Raw($line);
					}
				}
			}
		}
		return true;
	}
}
?>
