<?php

$file='CommandAPI.php';
while (!file_exists(realpath($file))){
	$file='../'.$file;
}
include($file);

include('bj_classes.php');
include('bj_common.php');

$Channels=Channel::getChannels();
$Player=null;
foreach ($Channels as $Chan){

	//echo 'Checking channel '.$Chan."\n";
	$Chan=new Channel($Chan);

	$Dealer=loadDealerData($Chan->getName());
	$Player=loadPlayerData($_User->getNick(), $Chan->getName());

	$TPlayers=$Dealer->getTotalPlayers();
	if ($TPlayers > 0){
		$CP=$Dealer->getPlayer($Dealer->getCurrentPlayer());
		//echo 'Looping though players in channel '.$Chan->getName()."\n";
		for ($i=0; $i<$TPlayers; $i++){
			$P=$Dealer->getPlayer($i);
			if ($P->getNick()==$Player->getNick()){
				//echo 'They were playing in '.$Chan->getName()."\n";
				$Dealer->removePlayer($Player->getNick());
				$Player->deduct($Player->getBet());
				Wise_msg($Chan->getName(), $Player->getNick().' has been removed from the game for leaving the channel.');
				if ($Dealer->isPlaying()){
					if ($Dealer->getTotalPlayers()==0){
						include('cmds/bj_results.php');
						break;
					}
					if ($CP->getNick()==$Player->getNick()){
						//Wise_msg('#wiser_bj', 'It was their turn.  Moving on.  Current Stage: '.$Dealer->getStage());
						switch ($Dealer->getStage()){
							case BJ_BETTING_R1:
								//Wise_msg('#wiser_bj', 'Betting phase one.');
								if (!$Dealer->nextPlayer()){
									//Wise_msg('#wiser_bj', 'Didn\'t get the next player.  Hit/stand time.');
									$Dealer->setStage(BJ_HIT_STAND);
									include('cmds/bj_hit_stand.php');
								}
								else {
									//Wise_msg('#wiser_bj', 'Did get the next player. Continue betting.');
									include('cmds/bj_bet.php');
								}
								break;
							case BJ_BETTING_R2:
								//Wise_msg('#wiser_bj', 'Betting phase two.');
								include('cmds/bj_results');
								break;
							case BJ_HIT_STAND:
								//Wise_msg('#wiser_bj', 'Hit/stand phase.');
								if (!$Dealer->nextPlayer()){
									//Wise_msg('#wiser_bj', 'Didn\'t get the next player.  Betting round two.');
									$Dealer->setStage(BJ_BETTING_R2);
										include('cmds/bj_bet.php');
								}
								else {
									//Wise_msg('#wiser_bj', 'Did get the next player. Continue Hitting.');
									include('cmds/bj_hit_stand.php');
								}
								break;
						}
					}		
				}
				break;
			}
		}
	}
	savePlayerData($Player, $Chan->getName());
	saveDealerData($Chan->getName(), serialize($Dealer));
}

?>
