<?php
$file='CommandAPI.php';
while (!file_exists(realpath($file))){
	$file='../'.$file;
}
include($file);
include('../bj_classes.php');
include('../bj_common.php');

if (!Channel::exists($INFO['DEST'])){
	exit;
}
$Chan=new Channel($INFO['DEST']);

$Dealer=loadDealerData($Chan->getName());
$Player=loadPlayerData($_User->getNick(), $Chan->getName());

$Msg=trim(substr($INFO['MSG'], 3));
$cmd=substr($Msg, 0, strpos($Msg.' ', ' '));
$cmd=strtolower($cmd);

switch ($cmd){
	case 'join':{
		include('./bj_join.php');
		break;
	}
	case 'play':{
		include('./bj_play.php');
		break;
	}
	case 'bet':{
		include('./bj_bet.php');
		break;
	}
	case 'hit':
	case 'stand':
	case 'stay':{
		include('./bj_hit_stand.php');
		break;
	}
	case 'money':{
		include('./bj_money.php');
		break;
	}
	case 'end':{
		if ($_User->getNick() == 'kicken' && $_User->isLoggedIn()){
			include('./bj_results.php');
		}
		break;
	}
	case 'restore_cash':{
		if ($_User->getNick() == $_Bot->getNick()){
			$User=trim(substr($Msg, strlen($cmd)));
			$res=db_query('SELECT Data FROM mod_blackjack_players WHERE Nick="'.$User.'" AND Channel="'.$Chan->getName().'"');
			if (!$res || db_num_rows($res)==0){
				break;
			}
			$data=db_result($res, 0, 0);
			$Player=unserialize($data);
			if ($Player->getMoney()<100){
				$Player->Money=100;
			}
			break;
		}
		break;
	}
	case 'timeout':{
		if ($_User->getNick() == $_Bot->getNick()){
			$Player=trim(substr($Msg, strlen($cmd)));
			$Player=loadPlayerData($Player, $Chan->getName());
			Wise_msg($Chan->getName(), $Player->getNick().' has timed out.');
			switch ($Dealer->getStage()){
				case BJ_BETTING_R1:
				case BJ_BETTING_R2:
					$bet=0;
					if ($Player->getMoney() > 20){
						$bet=20;
					}
					$cmd='bet';
					$Msg='bet '.$bet;
					include('./bj_bet.php');
					break;
				case BJ_HIT_STAND:
					$cmd='stand';
					$Msg='stand';
					include('./bj_hit_stand.php');
					break;
			}
		}
		break;
	}
	case 'donate':{
		include('./bj_donate.php');
		break;
	}
	case 'stats':{
		include('./bj_stats.php');
		break;
	}
	default:{
		Wise_Msg($Chan->getName(), 'Usage: !bj <join|hit|stand|bet|money|donate|stats>');
		break;
	}
}

if (!savePlayerData($Player, $Chan->getName())){
	Wise_Msg($Chan->getName(), 'Unable to save player data. Game over.');
	exit;
}
if (!saveDealerData($Chan->getName(), serialize($Dealer))){
	Wise_Msg($Chan->getName(), 'Unable to save game data.  Game over.');
}


?>
